/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.map.BasicPos
 *  fire.pb.map.GridPos
 *  fire.pb.map.MoveInfo
 *  fire.pb.map.Position
 *  fire.pb.scene.AreaInfo
 *  fire.pb.scene.BlockInfo
 *  fire.pb.scene.MapInfo
 *  fire.pb.scene.SceneManager
 *  fire.pb.scene.sPos.Position
 */
package fire.pb.util;

import fire.pb.map.BasicPos;
import fire.pb.map.GridPos;
import fire.pb.map.MoveInfo;
import fire.pb.scene.AreaInfo;
import fire.pb.scene.BlockInfo;
import fire.pb.scene.MapInfo;
import fire.pb.scene.SceneManager;
import fire.pb.scene.sPos.Position;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class MapUtil {
    public static int getBaseMapIdBySceneId(long sceneId) {
        int param = (int)(Math.pow(2.0, 32.0) - 1.0);
        Long mapId = sceneId & (long)param;
        return mapId.intValue();
    }

    public static long genSceneIDByCountor(int baseMapID, int counter) {
        long sceneId = MapUtil.convertInt2Long(counter);
        sceneId <<= 32;
        return sceneId += (long)baseMapID;
    }

    public static long convertInt2Long(int iValue) {
        Integer intValue = new Integer(iValue);
        return intValue.longValue();
    }

    public static List<Integer> checkEnterRegion(int prevmapId, int prevposx, int prevposy, int mapId, int posx, int posy) {
        return MapUtil.getRegionIdsByMapArea(mapId, MapUtil.checkChangeArea(prevmapId, prevposx, prevposy, mapId, posx, posy));
    }

    public static List<Integer> checkLeaveRegion(int prevmapId, int prevposx, int prevposy, int mapId, int posx, int posy) {
        return MapUtil.checkEnterRegion(mapId, posx, posy, prevmapId, prevposx, prevposy);
    }

    private static List<Short> checkChangeArea(int prevmapId, int prevposx, int prevposy, int mapId, int posx, int posy) {
        List<Short> enterAreas = MapUtil.getAreaTypes(mapId, posx, posy);
        if (enterAreas.isEmpty()) {
            return enterAreas;
        }
        if (prevmapId != mapId) {
            return enterAreas;
        }
        List<Short> oldAreas = MapUtil.getAreaTypes(mapId, prevposx, prevposy);
        if (oldAreas.isEmpty()) {
            return enterAreas;
        }
        Iterator<Short> it = enterAreas.iterator();
        while (it.hasNext()) {
            if (!oldAreas.contains(it.next())) continue;
            it.remove();
        }
        return enterAreas;
    }

    public static List<Integer> getRegionIds(int mapId, int posx, int posy) {
        return MapUtil.getRegionIdsByMapArea(mapId, MapUtil.getAreaTypes(mapId, posx, posy));
    }

    public static boolean isInRegion(int mapId, int posx, int posy, int regionId) {
        if (MapUtil.getMapIdByRegion(regionId) != mapId) {
            return false;
        }
        return MapUtil.getAreaTypes(mapId, posx, posy).contains((short)MapUtil.getAreaTypeByRegion(regionId));
    }

    public static boolean isInRegion2(int mapId, int posx, int posy, int regionId) {
        return MapUtil.getAreaTypes(mapId, posx, posy).contains((short)MapUtil.getAreaTypeByRegion(regionId));
    }

    public static AreaInfo getAreaInfo(int mapId, int gposx, int gposy) {
        BlockInfo blockinfo = MapUtil.getBlockInfo(mapId);
        if (blockinfo == null) {
            return null;
        }
        return (AreaInfo)blockinfo.getAreaInfos().get((gposx << 16) + gposy);
    }

    public static MapInfo getMapInfo(int mapId) {
        return SceneManager.getInstance().getMapInfo(mapId);
    }

    public static BlockInfo getBlockInfo(int mapId) {
        MapInfo mapinfo = MapUtil.getMapInfo(mapId);
        if (mapinfo == null) {
            return null;
        }
        return mapinfo.getBlockInfo();
    }

    public static List<Short> getAreaTypes(int mapId, int posx, int posy) {
        LinkedList<Short> areaTypes = new LinkedList<Short>();
        GridPos gpos = new fire.pb.map.Position(posx, posy).toGridPos();
        AreaInfo areaInfo = MapUtil.getAreaInfo(mapId, gpos.getX(), gpos.getY());
        if (areaInfo == null || areaInfo.getAreaTypes().isEmpty()) {
            return areaTypes;
        }
        areaTypes.addAll(areaInfo.getAreaTypes());
        return areaTypes;
    }

    public static List<Integer> getRegionIdsByMapArea(int mapId, List<Short> areaTypes) {
        LinkedList<Integer> regionIds = new LinkedList<Integer>();
        for (short areaType : areaTypes) {
            regionIds.add(MapUtil.getRegionIdByMapArea(mapId, areaType));
        }
        return regionIds;
    }

    public static int getRegionIdByMapArea(int mapId, short areaType) {
        return mapId * 100 + areaType;
    }

    public static int getMapIdByRegion(int regionId) {
        return regionId / 100;
    }

    public static int getAreaTypeByRegion(int regionId) {
        return regionId % 100;
    }

    public static fire.pb.map.Position getNextPositionByCurrent(fire.pb.map.Position curPosition, MoveInfo moveInfo) {
        fire.pb.map.Position start = moveInfo.getStartPoint();
        fire.pb.map.Position end = moveInfo.getEndPoint();
        int moveLength = moveInfo.getLength();
        int quadrant = moveInfo.getQuadrant();
        int xLength = Math.abs(start.getX() - end.getX());
        int yLength = Math.abs(start.getY() - end.getY());
        int slopeLength = end.getDistance((BasicPos)start);
        return MapUtil.getDesPostionBySimilarTriangle(curPosition, moveLength, quadrant, xLength, yLength, slopeLength);
    }

    private static fire.pb.map.Position getDesPostionBySimilarTriangle(fire.pb.map.Position curPosition, int moveLength, int quadrant, int xLength, int yLength, int slopeLength) {
        double scale = moveLength / slopeLength;
        int desX = MapUtil.getLengthByQuadrant(curPosition.getX(), quadrant, (int)((double)xLength * scale), true);
        int desY = MapUtil.getLengthByQuadrant(curPosition.getY(), quadrant, (int)((double)yLength * scale), false);
        return new fire.pb.map.Position(desX, desY);
    }

    private static int getLengthByQuadrant(int start, int quadrant, int addLength, boolean isX) {
        int result = 0;
        switch (quadrant) {
            case 1: {
                result = isX ? (result += addLength) : (result -= addLength);
            }
            case 2: {
                result += addLength;
            }
            case 3: {
                result = isX ? (result -= addLength) : (result += addLength);
            }
            case 4: {
                result -= addLength;
            }
        }
        result = result < 0 ? 0 : result;
        return result;
    }

    public static boolean checkWay(int mapId, List<fire.pb.map.Position> poses, short blocktype) {
        BlockInfo blockinfo = MapUtil.getBlockInfo(mapId);
        if (blockinfo == null) {
            return false;
        }
        int z = -1;
        LinkedList<Position> sceneposes = new LinkedList<Position>();
        for (fire.pb.map.Position pos : poses) {
            if (z == -1) {
                z = pos.getZ();
            } else if (z != pos.getZ()) {
                return false;
            }
            sceneposes.add(new Position(pos.getX(), pos.getY(), pos.getZ()));
        }
        if (z == -1) {
            return false;
        }
        return blockinfo.checkWay(sceneposes, blocktype);
    }
}

